"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElasticSearchService = void 0;
var Client = require("@elastic/elasticsearch").Client;
var http_service_1 = require("./http.service");
var ElasticSearchService = /** @class */ (function () {
    function ElasticSearchService(host, version) {
        if (host === void 0) { host = "http://localhost:9200"; }
        if (version === void 0) { version = "7.6"; }
        this.client = new Client({ node: host });
        this.httpService = new http_service_1.HttpService(host);
    }
    ElasticSearchService.prototype.addItem = function (index, obj) {
        return __awaiter(this, void 0, void 0, function () {
            var body;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.index({
                            index: index,
                            body: obj,
                        })];
                    case 1:
                        body = (_a.sent()).body;
                        this.refreshIndex(index);
                        return [2 /*return*/, body._id];
                }
            });
        });
    };
    ElasticSearchService.prototype.addMultipleItems = function (index, objArray) {
        return __awaiter(this, void 0, void 0, function () {
            var idsArr, _i, objArray_1, obj, id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('123');
                        idsArr = [];
                        _i = 0, objArray_1 = objArray;
                        _a.label = 1;
                    case 1:
                        if (!(_i < objArray_1.length)) return [3 /*break*/, 4];
                        obj = objArray_1[_i];
                        return [4 /*yield*/, this.addItem(index, obj)];
                    case 2:
                        id = _a.sent();
                        idsArr.push(id);
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, idsArr];
                }
            });
        });
    };
    ElasticSearchService.prototype.deleteDocumentByElasticId = function (index, id) {
        return __awaiter(this, void 0, void 0, function () {
            var ans;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpService.deleteByElasticIp(index, id)];
                    case 1:
                        ans = _a.sent();
                        console.log("ans: ", ans);
                        return [2 /*return*/, ans];
                }
            });
        });
    };
    ElasticSearchService.prototype.deleteByField = function (index, field, value) {
        return __awaiter(this, void 0, void 0, function () {
            var ans;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpService.deleteByField(index, field, value)];
                    case 1:
                        ans = _a.sent();
                        console.log("ans: ", ans);
                        return [2 /*return*/, ans];
                }
            });
        });
    };
    ElasticSearchService.prototype.deleteByMultipleFields = function (index, deleteObj) {
        return __awaiter(this, void 0, void 0, function () {
            var query, ans;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.buildQuery(deleteObj)];
                    case 1:
                        query = _a.sent();
                        return [4 /*yield*/, this.httpService.deleteByMultipleFields(index, query)];
                    case 2:
                        ans = _a.sent();
                        console.log("ans: ", ans);
                        return [2 /*return*/, ans];
                }
            });
        });
    };
    ElasticSearchService.prototype.searchByField = function (index, field, value) {
        return __awaiter(this, void 0, void 0, function () {
            var body, result;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.client.search({
                            index: index,
                            body: {
                                query: {
                                    match: (_a = {}, _a[field] = value, _a),
                                },
                            },
                        })];
                    case 1:
                        body = (_b.sent()).body;
                        return [4 /*yield*/, this.desrilize(body.hits.hits)];
                    case 2:
                        result = _b.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ElasticSearchService.prototype.search = function (index, searchObj) {
        return __awaiter(this, void 0, void 0, function () {
            var query, body, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.buildQuery(searchObj)];
                    case 1:
                        query = _a.sent();
                        return [4 /*yield*/, this.client.search({
                                index: index,
                                body: {
                                    query: {
                                        bool: {
                                            must: query,
                                        },
                                    },
                                },
                            })];
                    case 2:
                        body = (_a.sent()).body;
                        return [4 /*yield*/, this.desrilize(body.hits.hits)];
                    case 3:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ElasticSearchService.prototype.getByElasticId = function (index, id) {
        return __awaiter(this, void 0, void 0, function () {
            var result, result2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpService.getByElasticId(index, id)];
                    case 1:
                        result = _a.sent();
                        return [4 /*yield*/, this.desrilize(result)];
                    case 2:
                        result2 = _a.sent();
                        return [2 /*return*/, result2];
                }
            });
        });
    };
    ElasticSearchService.prototype.refreshIndex = function (index) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.indices.refresh({ index: index })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ElasticSearchService.prototype.buildQuery = function (obj) {
        return __awaiter(this, void 0, void 0, function () {
            var query, key;
            var _a;
            return __generator(this, function (_b) {
                query = [];
                for (key in obj) {
                    query.push({
                        match: (_a = {},
                            _a[key] = obj[key],
                            _a),
                    });
                }
                console.log("query: ", query);
                return [2 /*return*/, query];
            });
        });
    };
    ElasticSearchService.prototype.desrilize = function (obj) {
        return __awaiter(this, void 0, void 0, function () {
            var newObj;
            return __generator(this, function (_a) {
                if (!Array.isArray(obj)) {
                    obj = [obj];
                }
                newObj = obj.map(function (obj) {
                    return obj._source;
                });
                return [2 /*return*/, newObj];
            });
        });
    };
    return ElasticSearchService;
}());
exports.ElasticSearchService = ElasticSearchService;
//# sourceMappingURL=elastic.service.js.map